10 REM ---------------------------------
20 REM DEMO for MHEXT (Epson PX-8)
30 REM MHEXT must be in USER BIOS area
40 REM Martin Hepperle, 2019
50 REM ---------------------------------
60 REM The adresses of the functions:
70 TMODE=&HEA2C
80 GMODE=&HEA35
90 GLINE=&HEA00
100 CURPOS=&HEA53
110 TCHAR=&HEA6D
120 GPEN=&HEABD
130 GMOVE=&HEA82
140 GDRAW=&HEA8F
150 REM ---------------------------------
160 REM Demo starts here
170 C%=0
180 CALL GMODE(C%)
190 REM GOSUB 670
200 X0%=240 : Y0%=400 : CALL GMOVE(X0%,Y0%)
210 C%=1 : R=200
220 FOR S=0 TO 32 STEP .15708
230 IF C%=3 THEN C%=1 ELSE C%=C%+1
240 CALL GPEN(C%)
250 X0%=240+R*SIN(S)
260 Y0%=200+R*COS(S)
270 R=R-1
280 CALL GDRAW(X0%,Y0%)
290 NEXT S
300 Y0%=2 : Y1%=400
310 C%=0
320 FOR X0%=1 TO 480 STEP 4
330 X1%=480-X0%
340 C%=C%+1
350 CALL GLINE(X0%,Y0%,X1%,Y1%,C%)
360 NEXT X0%
370 X0%=2 : X1%=480
380 FOR Y0%=1 TO 400 STEP 4
390 Y1%=400-Y0%
400 C%=C%+1
410 CALL GLINE(X0%,Y0%,X1%,Y1%,C%)
420 NEXT Y0%
430 FOR X%=0 TO 480 STEP 2
440 Y0%=150*(1+COS(X%*3.14/120)^5)
450 Y1%=150*(1+SIN(X%*3.14/120)^3)
460 IF Y0%>Y1% THEN C%=1 ELSE C%=0
470 CALL GLINE (X%,Y0%,X%,Y1%,C%)
480 NEXT X%
490 REM ---------------------------------
500 C%=0
510 CALL TMODE(C%)
520 C%=12
530 CALL TCHAR(C%)
540 C%=12
550 CALL TCHAR(C%)
560 FOR C%=32 TO 127
570 X%=RND*80 : Y%=RND*24
580 CALL CURPOS(X%,Y%)
590 CALL TCHAR(C%)
600 IF (C% MOD 8) <>0 THEN GOTO 680
610 X%=1 : Y%=1
620 CALL CURPOS(X%,Y%)
630 T$=TIME$
640 FOR I=1 TO LEN(T$)
650 K%=ASC(MID$(T$,I,1))
660 CALL TCHAR(K%)
670 NEXT I
680 NEXT C%
690 X%=1 : Y%=1
700 CALL CURPOS(X%,Y%)
710 END
720 REM --- print rceive buffer ---
730 R=&HEB23
740 PRINT "EPSPKT: ";
750 FOR K=1 TO 16
760 PRINT HEX$(PEEK(R))+" ";
770 R=R+1
780 NEXT K
790 PRINT
800 R=&HEB33
810 PRINT "RCVBUF: ";
820 FOR K=1 TO 16
830 PRINT HEX$(PEEK(R))+" ";
840 R=R+1
850 NEXT K
860 PRINT
870 R=&HEB4B
880 PRINT "ERR: ";HEX$(PEEK(R))
890 RETURN
